module top(
  input wire I_CLK,
  input wire I_nRST,
  
  input wire I_ROAD_DETECT,
  input wire I_PED_DETECT,
  
  output wire O_ROAD_GREEN,
  output wire O_ROAD_RED,
  output wire O_ROAD_YELLOW,
  
  output wire O_PED_GREEN,
  output wire O_PED_RED
 );

wire RST_tmp;
wire RST = ~RST_tmp;
wire CLK;

wire ROAD_DETECT;
wire PED_DETECT;

reg ROAD_GREEN;
reg ROAD_RED;
reg ROAD_YELLOW;

reg PED_GREEN;
reg PED_RED;

reg [31:0] counter;
reg [24:0] blink_counter;
reg blink_flag;
reg red_flag;
reg green_flag;
reg [1:0] state;

IB my_instance_ib_rst (.I(I_nRST), .O(RST_tmp));
IB my_instance_ib_clk (.I(I_CLK),  .O(CLK));

IB my_instance_ib_road_detect (.I(I_ROAD_DETECT),  .O(ROAD_DETECT));
IB my_instance_ib_ped_detect (.I(I_PED_DETECT),  .O(PED_DETECT));

OB my_instance_ob_road_green (.I(ROAD_GREEN), .O(O_ROAD_GREEN));
OB my_instance_ob_road_red (.I(ROAD_RED), .O(O_ROAD_RED));
OB my_instance_ob_road_yellow (.I(ROAD_YELLOW), .O(O_ROAD_YELLOW));

OB my_instance_ob_ped_green (.I(PED_GREEN), .O(O_PED_GREEN));
OB my_instance_ob_ped_red (.I(PED_RED), .O(O_PED_RED));

always@(posedge CLK or posedge RST)
begin
  if(RST) 
    begin
      counter <= 32'd0;
	  blink_counter <= 0;
	  blink_flag <= 0;
	  red_flag <= 0;
	  green_flag <= 0;
	  state <= 2'b00;
    end
  else
    begin
		
		case(state)
			2'b00: begin //ped_detect ? rst
					ROAD_GREEN <= 1;
					ROAD_YELLOW <= 0;
					ROAD_RED <= 0;
					PED_GREEN <=1;
					PED_RED <= 0;
					counter <= 32'd0;
					if(PED_DETECT) begin state <= 2'b01; end
					if(ROAD_DETECT) begin state <= 2'b10; end
				end
			2'b01: begin //hoinka 
					if(blink_counter < 25_000_000 -1) begin//Tak nie nalezy robic patrz nizej jak zrobic
						blink_counter <= blink_counter +1;
						end
						else begin 
						blink_counter <= 0;
						blink_flag <= ~blink_flag;
						end
						
						
					ROAD_GREEN <= ~blink_flag;
					ROAD_YELLOW <= blink_flag;
					ROAD_RED <= ~blink_flag;
					PED_GREEN <=blink_flag;
					PED_RED <= ~blink_flag;
					counter <= 32'd0;
					if(PED_DETECT) begin state <= 2'b01; end
					if(ROAD_DETECT) begin state <= 2'b10; end
				end
			2'b10: begin //0.01s R_RED, 0.5s P_GREEN
					//counter <= 0;
					counter <= counter + 1;
					if(counter[19] == 1)begin red_flag<=1; end
					if(counter[25] == 1)begin green_flag<=1; end
		
					ROAD_GREEN <= 0;
					ROAD_YELLOW <= 0;
					ROAD_RED <= red_flag;
					PED_GREEN <=green_flag;
					PED_RED <= 0;
					//if(red_flag) begin state <= 2'b11; end
					if(PED_DETECT) begin state <= 2'b01; end
					if(ROAD_DETECT) begin state <= 2'b10; end
				end
			2'b11: begin
				
				end
    endcase
	end
end

endmodule